#include <stdlib.h>
#include <stdio.h>
#include <poll.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <netinet/ip.h>

//ERROR CODES:
//  1 malformed parameter

int udp_sender(int inaddr, int port){
  struct sockaddr_in addr;
  int sock = socket(AF_INET, SOCK_DGRAM, 0);
  addr.sin_family = AF_INET;
  addr.sin_port = htons(port);
  addr.sin_addr.s_addr = inaddr;
  connect(sock, (struct sockaddr *) &addr, sizeof(struct sockaddr_in));
  return sock;
}

char *icmp_error(int type, int code){
  switch(type){
  case 3: switch(code){
    case 3: return "Destination port unreachable"; break;
    default: return "Destination Unreachable"; break;
    } break;
  case 11: switch(code){
    case 3: return "Destination port unreachable"; break;
    case 0: return "TTL expired in transit"; break;
    default: return "Time Exceeded"; break;
    }break;
  default: return "Some funny unrecognized ICMP message"; break;
  }
}

int recv_err(int sock){
  struct pollfd fds; char buf[256];
  struct ip *iphdr = (struct ip *) buf;

  fds.fd = sock;
  fds.events = POLLIN;

  poll(&fds, 1, 5000);
  if (fds.revents & POLLIN){
    printf("%i bytes from ", recv(sock, buf, 256, 0));
    printf("%s: %s\n", inet_ntoa(iphdr->ip_src), icmp_error((int)buf[20], (int)buf[21]));
  }else printf("No response\n");

  return (int) (256 * (int)buf[20] + (int)buf[21]);
}

int main(int argc, char *argv[]){
  int ttl, sender, recverr, icmpmsg = 0;
  if ((argc < 2) || (inet_addr(argv[1]) == INADDR_NONE)) return 1;

  sender = udp_sender(inet_addr(argv[1]), 5959);
  recverr = socket(AF_INET, SOCK_RAW, IPPROTO_ICMP);

  for (ttl = 1; (ttl <= 30) && (icmpmsg != 771); ttl++){
    printf("TTL: %i - ", ttl);
    setsockopt(sender, IPPROTO_IP, IP_TTL, &ttl, sizeof(int));
    write(sender, "Hallo Welt!", 12);
    icmpmsg = recv_err(recverr);
  }

  return 0;
}
